var timerId;
var input = document.getElementById('edit-search');
var lastSearch = 0;
var contentDiv = document.getElementById('searchcontrol-results');
var searchControl;


google.load("search", "1");
google.setOnLoadCallback(OnLoad);

function OnLoad() {
  // Create a search control
  searchControl = new GSearchControl();

  // add a site-limited web search, with a custom label
  var siteSearch = new GwebSearch();
  siteSearch.setUserDefinedLabel("api.drupal.ru");
  siteSearch.setSiteRestriction("api.drupal.ru");
  
  var options = new google.search.SearcherOptions();
  options.setExpandMode(google.search.SearchControl.EXPAND_MODE_OPEN);

  searchControl.addSearcher(siteSearch, options);

  // setting the draw mode for the Google search
  var drawOptions = new GdrawOptions();
  drawOptions.setInput(input);
  searchControl.draw(document.getElementById("searchcontrol"), drawOptions);
  searchControl.setNoResultsString('Ничего не найдено.');

  // Preload keywords from referrer.
  $('#api-search-form .form-text').val(getkeywords());

  // Handle search appearance.
  $('#api-search-form .form-text').focus(function(){
    show_controls();
    $(this).addClass('focus');
  });
  $('#api-search-form .form-text').blur(function(){
    //$(this).removeClass('focus');
    //hide_controls();
  });
  $('.gsc-control, #api-search-form .form-submit, #api-search-form .form-text').mousemove(function(){show_controls(); });
  $('.gsc-control').mouseout(function(){ hide_controls(); });
  
  // Prevents default form submission if input isn't contain full term.
  $('#api-search-form .form-submit').click(function() {
    if (!$('#api-search-form .form-text').is('.complete')) {
      searchControl.execute(input.value);
      return false;
    }
    $(this).submit();
  });
  // ...on any other input, reset complete tag.
  $('#api-search-form .form-text').keydown(function(e){ if (e.keyCode != 13) { $(this).removeClass('complete'); } });
}

function show_controls() {
  $('.gsc-control').removeClass('tohide').stop();
  setTimeout("$('.gsc-control').fadeTo(200, 1);", 20);
}
function hide_controls() {
  if (!$('#api-search-form .form-text').is('.focus')) { 
    $('.gsc-control').addClass('tohide'); 
    $('.gsc-control').stop(); 
    setTimeout("$('.tohide').fadeOut(2000, function(){ searchControl.clearAllResults(); $('#api-search-form .form-text').removeClass('complete'); $('.gsc-control').removeClass('tohide').show(); });", 1000);
  }
}













/**
 * AUTOCOMPLETE OVERRIDES
 * Slashed areas — non-default behaviours.
 */

/**
 * Prevent annoying closing popup when you're entered
 * full value and pressed submit.
 */
Drupal.autocompleteSubmit = function () {
  $('#autocomplete').each(function () {
    this.owner.hidePopup();
  }).size() == 0;
};


/**
 * This one is triggered when term is selected from popup.
 */
Drupal.jsAC.prototype.hidePopup = function (keycode) {
  // Select item if the right key or mousebutton was pressed
  if (this.selected && ((keycode && keycode != 46 && keycode != 8 && keycode != 27) || !keycode)) {
    this.input.value = this.selected.autocompleteValue;

    //////////////////////////////////////
    // Place selection tag — field can be submitted.
    //////////////////////////////////////
    if (this.input.getAttribute("id") == 'edit-search') {
      window.setTimeout('searchControl.execute(\'' + this.input.value + '\')', 250);
    }
    $('#api-search-form .form-text').addClass('complete');
    ///////////////////////////////////////
  }

  ///////////////////////////////////////
  // Save input element for future.
  ///////////////////////////////////////
  input = $('#' + this.input.getAttribute("id"));
  ///////////////////////////////////////

  // Hide popup
  var popup = this.popup;
  if (popup) {
    this.popup = null;
    $(popup).fadeOut('fast', function() {
      $(popup).remove();
      ///////////////////////////////////////////////////
      // Place focus on input after  selection from list
      input.focus();
      //////////////////////////////////////////////////
    });
  }
  this.selected = false;
};

/**
 * This one is triggered on ajax load for terms list.
 */
Drupal.ACDB.prototype.search = function (searchString) {
  var db = this;
  this.searchString = searchString;

  ///////////////////////////////////////////////////
  // Check if cache already contains entered keyword
  ///////////////////////////////////////////////////
  matches = this.cache[searchString];
  for (key in matches) {
    if (matches[key] == $('#api-search-form .form-text').val()) {
      $('#api-search-form .form-text').addClass('complete');
    }
  }
  ////////////////////////////////////////////

  // See if this key has been searched for before
  if (this.cache[searchString]) {
    return this.owner.found(this.cache[searchString]);
  }

  // Initiate delayed search
  if (this.timer) {
    clearTimeout(this.timer);
  }
  this.timer = setTimeout(function() {
    db.owner.setStatus('begin');

    // Ajax GET request for autocompletion
    $.ajax({
      type: "GET",
      url: db.uri +'/'+ Drupal.encodeURIComponent(searchString),
      dataType: 'json',
      success: function (matches) {
        if (typeof matches['status'] == 'undefined' || matches['status'] != 0) {

          ////////////////////////////////////////////
          // Check if cache contains entered keyword
          ////////////////////////////////////////////
          for (key in matches) {
            if (matches[key] == $('#api-search-form .form-text').val()) {
              $('#api-search-form .form-text').addClass('complete');
            }
          }
          ///////////////////////////////////////////

          db.cache[searchString] = matches;
          // Verify if these are still the matches the user wants to see
          if (db.searchString == searchString) {
            db.owner.found(matches);
          }
          db.owner.setStatus('found');
        }
      },
      error: function (xmlhttp) {
        alert(Drupal.ahahError(xmlhttp, db.uri));
      }
    });
  }, this.delay);


};








/**
 * Preload keywords from referrer (if user gets from search engine).
 */
function getkeywords() {
  var x = "";
  var r = document.referrer;
  if (r.search(/google/) != -1 || r.search(/ask.com/) != -1 || r.search(/search.msn.com/) != -1) {
    patt = new RegExp("q=(.*?)(&)");
    matches = patt.exec(r);
    if (matches[1] != undefined) {
      x = matches[1];
    }
    else {
      x = "";
    }
  }
  else if (r.search(/yahoo/) != -1) {
    patt = new RegExp("p=(.*?)(&)");
    matches = patt.exec(r);
    if (matches[1] != undefined) {
      x = matches[1];
    }
    else {
      x = "";
    }
  }
  x = x.replace(/\+/g, " ");
  x = x.replace(/(\s)*(site:)*(www\.)*sourcemaking(\.com)*/g, "");
  return utf8_decode(x);
}

function utf8_decode(utftext) {
  utftext = unescape(utftext);
  var string = "";
  var i = 0;
  var c = c1 = c2 = 0;

  while ( i < utftext.length ) {

    c = utftext.charCodeAt(i);

    if (c < 128) {
      string += String.fromCharCode(c);
      i++;
    }
    else if((c > 191) && (c < 224)) {
      c2 = utftext.charCodeAt(i+1);
      string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
      i += 2;
    }
    else {
      c2 = utftext.charCodeAt(i+1);
      c3 = utftext.charCodeAt(i+2);
      string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
      i += 3;
    }
  }

  return string;
}


/**
 * Place focus on search on page start.
 */
$(document).ready(function(){
  // Extract anchor fragment from URL
  page_url = document.location.toString();
  // If there's no fragment, we can focus on search, otherwise we'll jump twicely on the page.
  if (!page_url.match('#')) {
    $('#api-search-form .form-text').focus();
  }
});
